//+------------------------------------------------------------------+
//|                                        Perevertysh20240512-1.mq5 |
//|                                                          Voronin |
//|                                      Virtual Trailing Stop 2.mq5 |
//|                              Copyright © 2020, Vladimir Karputov |
//|                     https://www.mql5.com/ru/market/product/43516 |
//|                                           http://wmua.ru/slesar/ |
//|                                                           Gerbut |
//|                                           andriygerbut@gmail.com |
//+------------------------------------------------------------------+
#property version   "1.00"
#property version   "1.000"
#property strict

// Libraries:
//+------------------------------------------------------------------+
#include <Trade\Trade.mqh>
#include <Trade\SymbolInfo.mqh>
#include <Trade\PositionInfo.mqh>
//#include <SecAuxLib.mqh>
#include <MT4Orders.mqh>

CPositionInfo     k_pos;
CSymbolInfo       m_symbol;
CTrade            m_trade;

//+------------------------------------------------------------------+
// Input parameters:
//+------------------------------------------------------------------+
enum ENUM_SYMBOL
{
    EURUSD  = 0,
    GPBUSD  = 1,
    USDCHF  = 2,
    BTCUSD  = 3,
    USDCAD  = 4,
    AUDCAD  = 5,
    NAZUSD  = 6,
    AUDCHF  = 7,
    AUDJPY  = 8,
    AUDUSD  = 9,
    BITCOIN = 10,
    XAUUSD  = 11,
    XAGUSD  = 12
};
input ENUM_SYMBOL     SYMBOL;
input ENUM_TIMEFRAMES TimeFrame       = PERIOD_CURRENT;
input double          LotSize         = 0.01; 
input ulong           Magic_m         = 9191;        // M1-9991,H1-9960,H4-9240,D2-1440,perevertysh-9191
input ulong           InpDeviation    = 10;          // Deviation, in points (1.00045-1.00055=10 points)
//+------------------------------------------------------------------+
double   SymbolPoint                  = SymbolInfoDouble(Symbol(),SYMBOL_POINT); // значение пункта цены
double   ask                          = NormalizeDouble(SymbolInfoDouble(Symbol(), SYMBOL_ASK),_Digits);
double   bid                          = NormalizeDouble(SymbolInfoDouble(Symbol(), SYMBOL_BID),_Digits);
double   spred                        = NormalizeDouble(SymbolInfoInteger(Symbol(),SYMBOL_SPREAD),_Digits);
//double   PerSpread                    = ((ask - bid) / ask) * 100;                          // Процент спреда
//double   PerVolatiliti                = SymbolInfoDouble(Symbol(),SYMBOL_PRICE_VOLATILITY); // Процент волатильности - не работает в mql5!
double   Tick_Size                    = SymbolInfoDouble(Symbol(),SYMBOL_TRADE_TICK_SIZE); // минимально возможное изменение цены
ulong    m_position_ticket            = 0;
ulong    ClosedTicket                 = 0;
MqlTradeRequest m_request;                            // структура торгового запроса
MqlTradeResult m_result;                              // структура результата торгового запроса
double   m_adjusted_point;                            // point value adjusted for 3 or 5 points
ulong    MS                           = 1000;
ulong    TFMS                         = PeriodSeconds(/*Period()*/ PERIOD_M1) * MS;

//+------------------------------------------------------------------+
// Methods-Events:                                                   |
//+------------------------------------------------------------------+
int OnInit()
{
   m_trade.SetExpertMagicNumber(Magic_m);
   if(!m_symbol.Name(Symbol()))                                                 // sets symbol name
     {
      Print(__FILE__," ",__FUNCTION__,", ERROR: CSymbolInfo.Name");
      return(INIT_FAILED);
     }
   RefreshRates();
//---
   m_trade.SetMarginMode();
   m_trade.SetTypeFillingBySymbol(m_symbol.Name());
   m_trade.SetDeviationInPoints(InpDeviation);

   m_adjusted_point             = SymbolPoint;                                     //m_symbol.Point()*digits_adjust;
//---
        EventSetMillisecondTimer(300);
        return (INIT_SUCCEEDED);
}
    
void OnTick()
{
   OnTimer();
}

void OnTimer()
{
   /*int         total            = PositionsTotal();
   for(int i=total-2; i>=0; i--)
   {
      k_pos.SelectByIndex(i);
      mposition_ticket = PositionGetTicket(i);
      string m_position_symbol       = k_pos.Symbol();
      long   m_position_magic        = k_pos.Magic();
      Print("total = ",(string)total,", mposition_ticket = ",(string)mposition_ticket,", m_position_magic = ",(string)m_position_magic);*/
        MqlTradeRequest tradeRequest = { };
        MqlTick last_tick;
        MqlTick current_tick;
        SymbolInfoTick(Symbol(),last_tick);
        SymbolInfoTick(Symbol(),current_tick);
        double ask0             = current_tick.ask;                               //SymbolInfoDouble(Symbol(), SYMBOL_ASK);
        double bid0             = current_tick.bid;
        ulong  time0            = current_tick.time_msc;
        ulong  timeOpen         = PositionGetInteger(POSITION_TIME_MSC);
        ENUM_POSITION_TYPE Type = (ENUM_POSITION_TYPE)PositionGetInteger(POSITION_TYPE); // тип позиции
        double Price            = PositionGetDouble(POSITION_PRICE_OPEN);
        double Tp               = PositionGetDouble(POSITION_TP);
        m_position_ticket       = PositionGetInteger(POSITION_TICKET);
        double lt               = PositionGetDouble(POSITION_VOLUME); // объем позиции
        ulong  magic            = PositionGetInteger(POSITION_MAGIC); // MagicNumber позиции
double VolatilitiUp1,VolatilitiUp2,VolatilitiUp3,VolatilitiUp4,VolatilitiUp5,VolatilitiUp6;
double VolatilitiLow1,VolatilitiLow2,VolatilitiLow3,VolatilitiLow4,VolatilitiLow5,VolatilitiLow6;
double Volatiliti       = 0;
double ask1,ask2,ask3,ask4,ask5,ask6;
double bid1,bid2,bid3,bid4,bid5,bid6;
double   PriceArr[]; // Создание массива цен
ArraySetAsSeries(PriceArr, true); // Сортировка данных
int      ATRDef                       = iATR(_Symbol,_Period,6); // определение ATR
CopyBuffer(ATRDef,0,0,3,PriceArr); // определяем данные и сохраняем результат
double   ATRValue                     = NormalizeDouble(PriceArr[0],_Digits); // Получаем значения текущих данных
MqlTick ticks[];
MqlTick tick;
SymbolInfoTick(Symbol(),tick);
  MqlTick mqlTick1[], symbTick1; // объявили переменные
  SymbolInfoTick(_Symbol, symbTick1); // это последний тик
  int copied1 = CopyTicksRange(_Symbol, mqlTick1, COPY_TICKS_INFO, symbTick1.time_msc, symbTick1.time_msc-10000); // цены за последние 10 секунд
  double bid_arr1[];
  ArrayResize(bid_arr1,copied1,100000);
  double ask_arr1[];
  ArrayResize(ask_arr1,copied1,100000);
  for(int i = 0; i < copied1; i++)
  {
            bid_arr1[i] = mqlTick1[i].bid;
            ask_arr1[i] = mqlTick1[i].ask;
            bid1        = NormalizeDouble(bid_arr1[0], _Digits); // первая цена bid за последние 10 секунд (аналог открытия текущего или закрытия предыдущего периода)
            ask1        = NormalizeDouble(ask_arr1[0], _Digits); // первая цена ask за последние 10 секунд (аналог открытия текущего или закрытия предыдущего периода)
     int    IndMaxBid   = ArrayMaximum(bid_arr1, 0, ArraySize(bid_arr1)-1);      // Индекс элемента массива bid_arr1 с максимальной ценой
     double highestBid  = bid_arr1[IndMaxBid];                      // Самая высокая цена bid за последние 10 секунд
     int    IndMinBid   = ArrayMinimum(bid_arr1, 0, ArraySize(bid_arr1)-1);      // Индекс элемента массива bid_arr1 с минимальной ценой
     double lowestBid   = bid_arr1[IndMinBid];                      // Самая низкая цена bid за последние 10 секунд
     int    IndMaxAsk   = ArrayMaximum(ask_arr1, 0, ArraySize(ask_arr1)-1);      // Индекс элемента массива ask_arr1 с максимальной ценой
     double highestAsk  = ask_arr1[IndMaxAsk];                      // Самая высокая цена ask за последние 10 секунд
     int    IndMinAsk   = ArrayMinimum(ask_arr1, 0, ArraySize(ask_arr1)-1);      // Индекс элемента массива ask_arr1 с минимальной ценой
     double lowestAsk   = ask_arr1[IndMinAsk];                      // Самая низкая цена ask за последние 10 секунд
     double highestHigh = (highestBid+highestAsk)/2;               // Средняя наибольшего ask и наибольшего bid элемента
     double lowestLow   = (lowestBid+lowestAsk)/2;                 // Средняя наименьшего ask и наименьшего bid элемента
     if(highestHigh - (ask0 + bid0 + bid1 + ask1)/4 >= (ask0 + bid0 + bid1 + ask1)/4 - lowestLow)
     {
        VolatilitiUp1 = highestHigh - (ask0 + bid0 + bid1 + ask1)/4;
        VolatilitiLow1 = 0;
     }
     else if(highestHigh - (ask0 + bid0 + bid1 + ask1)/4 < (ask0 + bid0 + bid1 + ask1)/4 - lowestLow)
     {
        VolatilitiLow1 = (ask0 + bid0 + bid1 + ask1)/4 - lowestLow;
        VolatilitiUp1 = 0;
     }
  }
  MqlTick mqlTick2[], symbTick2; // объявили переменные
  SymbolInfoTick(_Symbol, symbTick2); // это последний тик
  int copied2 = CopyTicksRange(_Symbol, mqlTick2, COPY_TICKS_INFO, symbTick2.time_msc-10000, symbTick2.time_msc-20000); // цены между 10 секунд и 20 секунд назад
  double bid_arr2[];
  ArrayResize(bid_arr2,copied2,100000);
  double ask_arr2[];
  ArrayResize(ask_arr2,copied2,100000);
  for(int i = 0; i < copied2; i++)
  {
            bid_arr2[i] = mqlTick2[i].bid;
            ask_arr2[i] = mqlTick2[i].ask;
            bid2        = NormalizeDouble(bid_arr2[0], _Digits); // первая цена bid между 10 секунд и 20 секунд назад (аналог открытия текущего или закрытия предыдущего периода)
            ask2        = NormalizeDouble(ask_arr2[0], _Digits); // первая цена ask между 10 секунд и 20 секунд назад (аналог открытия текущего или закрытия предыдущего периода)
     int    IndMaxBid   = ArrayMaximum(bid_arr2, 0, ArraySize(bid_arr2)-1);      // Индекс элемента массива bid_arr2 с максимальной ценой
     double highestBid  = bid_arr2[IndMaxBid];                      // Самая высокая цена bid между 10 секунд и 20 секунд назад
     int    IndMinBid   = ArrayMinimum(bid_arr2, 0, ArraySize(bid_arr2)-1);      // Индекс элемента массива bid_arr2 с минимальной ценой
     double lowestBid   = bid_arr2[IndMinBid];                      // Самая низкая цена bid между 10 секунд и 20 секунд назад
     int    IndMaxAsk   = ArrayMaximum(ask_arr2, 0, ArraySize(ask_arr2)-1);      // Индекс элемента массива ask_arr2 с максимальной ценой
     double highestAsk  = ask_arr2[IndMaxAsk];                      // Самая высокая цена ask между 10 секунд и 20 секунд назад
     int    IndMinAsk   = ArrayMinimum(ask_arr2, 0, ArraySize(ask_arr2)-1);      // Индекс элемента массива ask_arr2 с минимальной ценой
     double lowestAsk   = ask_arr2[IndMinAsk];                      // Самая низкая цена ask между 20 секунд и 20 секунд назад
     double highestHigh = (highestBid+highestAsk)/2;               // Средняя наибольшего ask и наибольшего bid элемента
     double lowestLow   = (lowestBid+lowestAsk)/2;                 // Средняя наименьшего ask и наименьшего bid элемента
     if(highestHigh - (ask1 + bid1 + bid2 + ask2)/4 >= (ask1 + bid1 + bid2 + ask2)/4)
     {
        VolatilitiUp2 = highestHigh - (ask1 + bid1 + bid2 + ask2)/4;
        VolatilitiLow2 = 0;
     }
     else if(highestHigh - (ask1 + bid1 + bid2 + ask2)/4 < (ask1 + bid1 + bid2 + ask2)/4 - lowestLow)
     {
        VolatilitiLow2 = (ask1 + bid1 + bid2 + ask2)/4 - lowestLow;
        VolatilitiUp2 = 0;
     }
  }
  MqlTick mqlTick3[], symbTick3; // объявили переменные
  SymbolInfoTick(_Symbol, symbTick3); // это последний тик
  int copied3 = CopyTicksRange(_Symbol, mqlTick3, COPY_TICKS_INFO, symbTick3.time_msc-20000, symbTick3.time_msc-30000); // цены между 20 секунд и 30 секунд назад
  double bid_arr3[];
  ArrayResize(bid_arr3,copied3,100000);
  double ask_arr3[];
  ArrayResize(ask_arr3,copied3,100000);
  for(int i = 0; i < copied3; i++)
  {
            bid_arr3[i] = mqlTick3[i].bid;
            ask_arr3[i] = mqlTick3[i].ask;
            bid3        = NormalizeDouble(bid_arr3[0], _Digits); // первая цена bid между 20 секунд и 30 секунд назад (аналог открытия текущего или закрытия предыдущего периода)
            ask3        = NormalizeDouble(ask_arr3[0], _Digits); // первая цена ask между 20 секунд и 30 секунд назад (аналог открытия текущего или закрытия предыдущего периода)
     int    IndMaxBid   = ArrayMaximum(bid_arr3, 0, ArraySize(bid_arr3)-1);      // Индекс элемента массива bid_arr3 с максимальной ценой
     double highestBid  = bid_arr3[IndMaxBid];                      // Самая высокая цена bid между 10 секунд и 30 секунд назад
     int    IndMinBid   = ArrayMinimum(bid_arr3, 0, ArraySize(bid_arr3)-1);      // Индекс элемента массива bid_arr3 с минимальной ценой
     double lowestBid   = bid_arr3[IndMinBid];                      // Самая низкая цена bid между 20 секунд и 30 секунд назад
     int    IndMaxAsk   = ArrayMaximum(ask_arr3, 0, ArraySize(ask_arr3)-1);      // Индекс элемента массива ask_arr3 с максимальной ценой
     double highestAsk  = ask_arr3[IndMaxAsk];                      // Самая высокая цена ask между 20 секунд и 30 секунд назад
     int    IndMinAsk   = ArrayMinimum(ask_arr3, 0, ArraySize(ask_arr3)-1);      // Индекс элемента массива ask_arr3 с минимальной ценой
     double lowestAsk   = ask_arr3[IndMinAsk];                      // Самая низкая цена ask между 20 секунд и 30 секунд назад
     double highestHigh = (highestBid+highestAsk)/2;               // Средняя наибольшего ask и наибольшего bid элемента
     double lowestLow   = (lowestBid+lowestAsk)/2;                 // Средняя наименьшего ask и наименьшего bid элемента
     if(highestHigh - (ask2 + bid2 + bid3 + ask3)/4 >= (ask2 + bid2 + bid3 + ask3)/4 - lowestLow)
     {
        VolatilitiUp3 = highestHigh - (ask2 + bid2 + bid3 + ask3)/4;
        VolatilitiLow3 = 0;
     }
     else if(highestHigh - (ask2 + bid2 + bid3 + ask3)/4 < (ask2 + bid2 + bid3 + ask3)/4 - lowestLow)
     {
        VolatilitiLow3 = (ask2 + bid2 + bid3 + ask3)/4 - lowestLow;
        VolatilitiUp3 = 0;
     }
  }
  MqlTick mqlTick4[], symbTick4; // объявили переменные
  SymbolInfoTick(_Symbol, symbTick4); // это последний тик
  int copied4 = CopyTicksRange(_Symbol, mqlTick4, COPY_TICKS_INFO, symbTick4.time_msc-30000, symbTick4.time_msc-40000); // цены между 30 секунд и 40 секунд назад
  double bid_arr4[];
  ArrayResize(bid_arr4,copied4,100000);
  double ask_arr4[];
  ArrayResize(ask_arr4,copied4,100000);
  for(int i = 0; i < copied4; i++)
  {
            bid_arr4[i] = mqlTick4[i].bid;
            ask_arr4[i] = mqlTick4[i].ask;
            bid4        = NormalizeDouble(bid_arr4[0], _Digits); // первая цена bid между 30 секунд и 40 секунд назад (аналог открытия текущего или закрытия предыдущего периода)
            ask4        = NormalizeDouble(ask_arr4[0], _Digits); // первая цена ask между 30 секунд и 40 секунд назад (аналог открытия текущего или закрытия предыдущего периода)
     int    IndMaxBid   = ArrayMaximum(bid_arr4, 0, ArraySize(bid_arr4)-1);      // Индекс элемента массива bid_arr4 с максимальной ценой
     double highestBid  = bid_arr4[IndMaxBid];                      // Самая высокая цена bid между 30 секунд и 40 секунд назад
     int    IndMinBid   = ArrayMinimum(bid_arr4, 0, ArraySize(bid_arr4)-1);      // Индекс элемента массива bid_arr4 с минимальной ценой
     double lowestBid   = bid_arr4[IndMinBid];                      // Самая низкая цена bid между 30 секунд и 40 секунд назад
     int    IndMaxAsk   = ArrayMaximum(ask_arr4, 0, ArraySize(ask_arr4)-1);      // Индекс элемента массива ask_arr4 с максимальной ценой
     double highestAsk  = ask_arr4[IndMaxAsk];                      // Самая высокая цена ask между 30 секунд и 40 секунд назад
     int    IndMinAsk   = ArrayMinimum(ask_arr4, 0, ArraySize(ask_arr4)-1);      // Индекс элемента массива ask_arr4 с минимальной ценой
     double lowestAsk   = ask_arr4[IndMinAsk];                      // Самая низкая цена ask между 30 секунд и 40 секунд назад
     double highestHigh = (highestBid+highestAsk)/2;               // Средняя наибольшего ask и наибольшего bid элемента
     double lowestLow   = (lowestBid+lowestAsk)/2;                 // Средняя наименьшего ask и наименьшего bid элемента
     if(highestHigh - (ask3 + bid3 + bid4 + ask4)/4 >= (ask3 + bid3 + bid4 + ask4)/4 - lowestLow)
     {
        VolatilitiUp4 = highestHigh - (ask3 + bid3 + bid4 + ask4)/4;
        VolatilitiLow4 = 0;
     }
     else if(highestHigh - (ask3 + bid3 + bid4 + ask4)/4 < (ask3 + bid3 + bid4 + ask4)/4 - lowestLow)
     {
        VolatilitiLow4 = (ask3 + bid3 + bid4 + ask4)/4 - lowestLow;
        VolatilitiUp4 = 0;
     }
  }
  MqlTick mqlTick5[], symbTick5; // объявили переменные
  SymbolInfoTick(_Symbol, symbTick5); // это последний тик
  int copied5 = CopyTicksRange(_Symbol, mqlTick5, COPY_TICKS_INFO, symbTick5.time_msc-40000, symbTick5.time_msc-50000); // цены между 40 секунд и 50 секунд назад
  double bid_arr5[];
  ArrayResize(bid_arr5,copied5,100000);
  double ask_arr5[];
  ArrayResize(ask_arr5,copied5,100000);
  for(int i = 0; i < copied5; i++)
  {
            bid_arr5[i] = mqlTick5[i].bid;
            ask_arr5[i] = mqlTick5[i].ask;
            bid5        = NormalizeDouble(bid_arr5[0], _Digits); // первая цена bid между 40 секунд и 50 секунд назад (аналог открытия текущего или закрытия предыдущего периода)
            ask5        = NormalizeDouble(ask_arr5[0], _Digits); // первая цена ask между 40 секунд и 50 секунд назад (аналог открытия текущего или закрытия предыдущего периода)
     int    IndMaxBid   = ArrayMaximum(bid_arr5, 0, ArraySize(bid_arr5)-1);      // Индекс элемента массива bid_arr5 с максимальной ценой
     double highestBid  = bid_arr5[IndMaxBid];                      // Самая высокая цена bid между 40 секунд и 50 секунд назад
     int    IndMinBid   = ArrayMinimum(bid_arr5, 0, ArraySize(bid_arr5)-1);      // Индекс элемента массива bid_arr5 с минимальной ценой
     double lowestBid   = bid_arr5[IndMinBid];                      // Самая низкая цена bid между 40 секунд и 50 секунд назад
     int    IndMaxAsk   = ArrayMaximum(ask_arr5, 0, ArraySize(ask_arr5)-1);      // Индекс элемента массива ask_arr5 с максимальной ценой
     double highestAsk  = ask_arr5[IndMaxAsk];                      // Самая высокая цена ask между 40 секунд и 50 секунд назад
     int    IndMinAsk   = ArrayMinimum(ask_arr5, 0, ArraySize(ask_arr5)-1);      // Индекс элемента массива ask_arr5 с минимальной ценой
     double lowestAsk   = ask_arr5[IndMinAsk];                      // Самая низкая цена ask между 40 секунд и 50 секунд назад
     double highestHigh = (highestBid+highestAsk)/2;               // Средняя наибольшего ask и наибольшего bid элемента
     double lowestLow   = (lowestBid+lowestAsk)/2;                 // Средняя наименьшего ask и наименьшего bid элемента
     if(highestHigh - (ask4 + bid4 + bid5 + ask5)/4 >= (ask4 + bid4 + bid5 + ask5)/4 - lowestLow)
     {
        VolatilitiUp5 = highestHigh - (ask4 + bid4 + bid5 + ask5)/4;
        VolatilitiLow5 = 0;
     }
     else if(highestHigh - (ask4 + bid4 + bid5 + ask5)/4 < (ask4 + bid4 + bid5 + ask5)/4 - lowestLow)
     {
        VolatilitiLow5 = (ask4 + bid4 + bid5 + ask5)/4 - lowestLow;
        VolatilitiUp5 = 0;
     }
  }
  MqlTick mqlTick6[], symbTick6; // объявили переменные
  SymbolInfoTick(_Symbol, symbTick6); // это последний тик
  int copied6 = CopyTicksRange(_Symbol, mqlTick6, COPY_TICKS_INFO, symbTick6.time_msc-40000, symbTick6.time_msc-60000); // цены между 50 секунд и 60 секунд назад
  double bid_arr6[];
  ArrayResize(bid_arr6,copied6,100000);
  double ask_arr6[];
  ArrayResize(ask_arr6,copied6,100000);
  for(int i = 0; i < copied6; i++)
  {
            bid_arr6[i] = mqlTick6[i].bid;
            ask_arr6[i] = mqlTick6[i].ask;
            bid6        = NormalizeDouble(bid_arr6[0], _Digits); // первая цена bid между 50 секунд и 60 секунд назад (аналог открытия текущего или закрытия предыдущего периода)
            ask6        = NormalizeDouble(ask_arr6[0], _Digits); // первая цена ask между 50 секунд и 60 секунд назад (аналог открытия текущего или закрытия предыдущего периода)
     int    IndMaxBid   = ArrayMaximum(bid_arr6, 0, ArraySize(bid_arr6)-1);      // Индекс элемента массива bid_arr6 с максимальной ценой
     double highestBid  = bid_arr6[IndMaxBid];                      // Самая высокая цена bid между 50 секунд и 60 секунд назад
     int    IndMinBid   = ArrayMinimum(bid_arr6, 0, ArraySize(bid_arr6)-1);      // Индекс элемента массива bid_arr6 с минимальной ценой
     double lowestBid   = bid_arr6[IndMinBid];                      // Самая низкая цена bid между 50 секунд и 60 секунд назад
     int    IndMaxAsk   = ArrayMaximum(ask_arr6, 0, ArraySize(ask_arr6)-1);      // Индекс элемента массива ask_arr6 с максимальной ценой
     double highestAsk  = ask_arr6[IndMaxAsk];                      // Самая высокая цена ask между 50 секунд и 60 секунд назад
     int    IndMinAsk   = ArrayMinimum(ask_arr6, 0, ArraySize(ask_arr6)-1);      // Индекс элемента массива ask_arr6 с минимальной ценой
     double lowestAsk   = ask_arr6[IndMinAsk];                      // Самая низкая цена ask между 50 секунд и 60 секунд назад
     double highestHigh = (highestBid+highestAsk)/2;               // Средняя наибольшего ask и наибольшего bid элемента
     double lowestLow   = (lowestBid+lowestAsk)/2;                 // Средняя наименьшего ask и наименьшего bid элемента
     if(highestHigh - (ask4 + bid4 + bid5 + ask5)/4 >= (ask4 + bid4 + bid5 + ask5)/4 - lowestLow)
     {
        VolatilitiUp6 = highestHigh - (ask4 + bid4 + bid5 + ask5)/4;
        VolatilitiLow6 = 0;
     }
     else if(highestHigh - (ask4 + bid4 + bid5 + ask5)/4 < (ask4 + bid4 + bid5 + ask5)/4 - lowestLow)
     {
        VolatilitiLow6 = (ask4 + bid4 + bid5 + ask5)/4 - lowestLow;
        VolatilitiUp6 = 0;
     }
  }
if(VolatilitiLow1>0&&VolatilitiLow2>0&&VolatilitiLow3>0&&VolatilitiLow4>0&&VolatilitiLow5>0&&VolatilitiLow6>0)
{
   double Volatiliti=VolatilitiLow1+VolatilitiLow2+VolatilitiLow3+VolatilitiLow4+VolatilitiLow5+VolatilitiLow6;
}
if(VolatilitiLow1>0&&VolatilitiLow2>0&&VolatilitiLow3>0&&VolatilitiLow4>0&&VolatilitiLow5>0&&VolatilitiLow6==0)
{
   double Array1[]={(VolatilitiLow1+VolatilitiLow2+VolatilitiLow3+VolatilitiLow4+VolatilitiLow5),VolatilitiUp6};
   int IndMax=ArrayMaximum(Array1,WHOLE_ARRAY,0);
   Volatiliti=Array1[IndMax];
}
if(VolatilitiLow1>0&&VolatilitiLow2>0&&VolatilitiLow3>0&&VolatilitiLow4>0&&VolatilitiLow5==0&&VolatilitiLow6>0)
{
   double Array2[]={(VolatilitiLow1+VolatilitiLow2+VolatilitiLow3+VolatilitiLow4),VolatilitiUp5,VolatilitiLow6};
   int IndMax=ArrayMaximum(Array2,WHOLE_ARRAY,0);
   Volatiliti=Array2[IndMax];
}
if(VolatilitiLow1>0&&VolatilitiLow2>0&&VolatilitiLow3>0&&VolatilitiLow4>0&&VolatilitiLow5==0&&VolatilitiLow6==0)
{
   double Array3[]={(VolatilitiLow1+VolatilitiLow2+VolatilitiLow3+VolatilitiLow4),(VolatilitiUp5+VolatilitiUp6)};
   int IndMax=ArrayMaximum(Array3,WHOLE_ARRAY,0);
   Volatiliti=Array3[IndMax];
}
if(VolatilitiLow1>0&&VolatilitiLow2>0&&VolatilitiLow3>0&&VolatilitiLow4==0&&VolatilitiLow5>0&&VolatilitiLow6>0)
{
   double Array4[]={(VolatilitiLow2+VolatilitiLow2+VolatilitiLow3),VolatilitiUp4,(VolatilitiLow5+VolatilitiLow6)};
   int IndMax=ArrayMaximum(Array4,WHOLE_ARRAY,0);
   Volatiliti=Array4[IndMax];
}
if(VolatilitiLow1>0&&VolatilitiLow2>0&&VolatilitiLow3>0&&VolatilitiLow4==0&&VolatilitiLow5>0&&VolatilitiLow6==0)
{
   double Array5[]={(VolatilitiLow1+VolatilitiLow2+VolatilitiLow3),VolatilitiUp4,VolatilitiLow5,VolatilitiUp6};
   int IndMax=ArrayMaximum(Array5,WHOLE_ARRAY,0);
   Volatiliti=Array5[IndMax];
}
if(VolatilitiLow1>0&&VolatilitiLow2>0&&VolatilitiLow3>0&&VolatilitiLow4==0&&VolatilitiLow5==0&&VolatilitiLow6>0)
{
   double Array6[]={(VolatilitiLow1+VolatilitiLow2+VolatilitiLow3),(VolatilitiUp4+VolatilitiUp5),VolatilitiLow6};
   int IndMax=ArrayMaximum(Array6,WHOLE_ARRAY,0);
   Volatiliti=Array6[IndMax];
}
if(VolatilitiLow1>0&&VolatilitiLow2>0&&VolatilitiLow3>0&&VolatilitiLow4==0&&VolatilitiLow5==0&&VolatilitiLow6==0)
{
   double Array7[]={(VolatilitiLow1+VolatilitiLow2+VolatilitiLow3),(VolatilitiUp4+VolatilitiUp5+VolatilitiUp6)};
   int IndMax=ArrayMaximum(Array7,WHOLE_ARRAY,0);
   Volatiliti=Array7[IndMax];
}
if(VolatilitiLow1>0&&VolatilitiLow2>0&&VolatilitiLow3==0&&VolatilitiLow4>0&&VolatilitiLow5>0&&VolatilitiLow6>0)
{
   double Array8[]={(VolatilitiLow1+VolatilitiLow2),VolatilitiUp3,(VolatilitiLow4+VolatilitiLow5+VolatilitiLow6)};
   int IndMax=ArrayMaximum(Array8,WHOLE_ARRAY,0);
   Volatiliti=Array8[IndMax];
}
if(VolatilitiLow1>0&&VolatilitiLow2>0&&VolatilitiLow3==0&&VolatilitiLow4>0&&VolatilitiLow5>0&&VolatilitiLow6==0)
{
   double Array9[]={(VolatilitiLow1+VolatilitiLow2),VolatilitiUp3,(VolatilitiLow4+VolatilitiLow5),VolatilitiUp6};
   int IndMax=ArrayMaximum(Array9,WHOLE_ARRAY,0);
   Volatiliti=Array9[IndMax];
}
if(VolatilitiLow1>0&&VolatilitiLow2>0&&VolatilitiLow3==0&&VolatilitiLow4>0&&VolatilitiLow5==0&&VolatilitiLow6>0)
{
   double Array10[]={(VolatilitiLow1+VolatilitiLow2),VolatilitiUp3,VolatilitiLow4,VolatilitiUp5,VolatilitiLow6};
   int IndMax=ArrayMaximum(Array10,WHOLE_ARRAY,0);
   Volatiliti=Array10[IndMax];
}
if(VolatilitiLow1>0&&VolatilitiLow2>0&&VolatilitiLow3==0&&VolatilitiLow4>0&&VolatilitiLow5==0&&VolatilitiLow6==0)
{
   double Array11[]={(VolatilitiLow1+VolatilitiLow2),VolatilitiUp3,VolatilitiLow4,(VolatilitiUp5+VolatilitiUp6)};
   int IndMax=ArrayMaximum(Array11,WHOLE_ARRAY,0);
   Volatiliti=Array11[IndMax];
}
if(VolatilitiLow1>0&&VolatilitiLow2>0&&VolatilitiLow3==0&&VolatilitiLow4==0&&VolatilitiLow5>0&&VolatilitiLow6>0)
{
   double Array12[]={(VolatilitiLow1+VolatilitiLow2),(VolatilitiUp3+VolatilitiUp4),(VolatilitiLow5+VolatilitiLow6)};
   int IndMax=ArrayMaximum(Array12,WHOLE_ARRAY,0);
   Volatiliti=Array12[IndMax];
}
if(VolatilitiLow1>0&&VolatilitiLow2>0&&VolatilitiLow3==0&&VolatilitiLow4==0&&VolatilitiLow5>0&&VolatilitiLow6==0)
{
   double Array13[]={(VolatilitiLow1+VolatilitiLow2),(VolatilitiUp3+VolatilitiUp4),VolatilitiLow5,VolatilitiUp6};
   int IndMax=ArrayMaximum(Array13,WHOLE_ARRAY,0);
   Volatiliti=Array13[IndMax];
}
if(VolatilitiLow1>0&&VolatilitiLow2>0&&VolatilitiLow3==0&&VolatilitiLow4==0&&VolatilitiLow5==0&&VolatilitiLow6>0)
{
   double Array14[]={(VolatilitiLow1+VolatilitiLow2),(VolatilitiUp3+VolatilitiUp4+VolatilitiUp5),VolatilitiLow6};
   int IndMax=ArrayMaximum(Array14,WHOLE_ARRAY,0);
   Volatiliti=Array14[IndMax];
}
if(VolatilitiLow1>0&&VolatilitiLow2>0&&VolatilitiLow3==0&&VolatilitiLow4==0&&VolatilitiLow5==0&&VolatilitiLow6==0)
{
   double Array15[]={(VolatilitiLow1+VolatilitiLow2),(VolatilitiUp3+VolatilitiUp4+VolatilitiUp5+VolatilitiUp6)};
   int IndMax=ArrayMaximum(Array15,WHOLE_ARRAY,0);
   Volatiliti=Array15[IndMax];
}
if(VolatilitiLow1>0&&VolatilitiLow2==0&&VolatilitiLow3>0&&VolatilitiLow4>0&&VolatilitiLow5>0&&VolatilitiLow6>0)
{
   double Array16[]={VolatilitiLow1,VolatilitiUp2,(VolatilitiLow3+VolatilitiLow4+VolatilitiLow5+VolatilitiLow6)};
   int IndMax=ArrayMaximum(Array16,WHOLE_ARRAY,0);
   Volatiliti=Array16[IndMax];
}
if(VolatilitiLow1>0&&VolatilitiLow2==0&&VolatilitiLow3>0&&VolatilitiLow4>0&&VolatilitiLow5>0&&VolatilitiLow6==0)
{
   double Array17[]={VolatilitiLow1,VolatilitiUp2,(VolatilitiLow3+VolatilitiLow4+VolatilitiLow5),VolatilitiUp6};
   int IndMax=ArrayMaximum(Array17,WHOLE_ARRAY,0);
   Volatiliti=Array17[IndMax];
}
if(VolatilitiLow1>0&&VolatilitiLow2==0&&VolatilitiLow3>0&&VolatilitiLow4>0&&VolatilitiLow5==0&&VolatilitiLow6>0)
{
   double Array18[]={VolatilitiLow1,VolatilitiUp2,(VolatilitiLow3+VolatilitiLow4),VolatilitiUp5,VolatilitiLow6};
   int IndMax=ArrayMaximum(Array18,WHOLE_ARRAY,0);
   Volatiliti=Array18[IndMax];
}
if(VolatilitiLow1>0&&VolatilitiLow2==0&&VolatilitiLow3>0&&VolatilitiLow4>0&&VolatilitiLow5==0&&VolatilitiLow6==0)
{
   double Array19[]={VolatilitiLow1,VolatilitiUp2,(VolatilitiLow3+VolatilitiLow4),(VolatilitiUp5+VolatilitiUp6)};
   int IndMax=ArrayMaximum(Array19,WHOLE_ARRAY,0);
   Volatiliti=Array19[IndMax];
}
if(VolatilitiLow1>0&&VolatilitiLow2==0&&VolatilitiLow3>0&&VolatilitiLow4==0&&VolatilitiLow5>0&&VolatilitiLow6>0)
{
   double Array20[]={VolatilitiLow1,VolatilitiUp2,VolatilitiLow3,VolatilitiUp4,(VolatilitiLow5+VolatilitiLow6)};
   int IndMax=ArrayMaximum(Array20,WHOLE_ARRAY,0);
   Volatiliti=Array20[IndMax];
}
if(VolatilitiLow1>0&&VolatilitiLow2==0&&VolatilitiLow3>0&&VolatilitiLow4==0&&VolatilitiLow5>0&&VolatilitiLow6==0)
{
   double Array21[]={VolatilitiLow1,VolatilitiUp2,VolatilitiLow3,VolatilitiUp4,VolatilitiLow5,VolatilitiUp6};
   int IndMax=ArrayMaximum(Array21,WHOLE_ARRAY,0);
   Volatiliti=Array21[IndMax];
}
if(VolatilitiLow1>0&&VolatilitiLow2==0&&VolatilitiLow3>0&&VolatilitiLow4==0&&VolatilitiLow5==0&&VolatilitiLow6>0)
{
   double Array22[]={VolatilitiLow1,VolatilitiUp2,VolatilitiLow3,(VolatilitiUp4+VolatilitiUp5),VolatilitiLow6};
   int IndMax=ArrayMaximum(Array22,WHOLE_ARRAY,0);
   Volatiliti=Array22[IndMax];
}
if(VolatilitiLow1>0&&VolatilitiLow2==0&&VolatilitiLow3>0&&VolatilitiLow4==0&&VolatilitiLow5==0&&VolatilitiLow6==0)
{
   double Array23[]={VolatilitiLow1,VolatilitiUp2,VolatilitiLow3,(VolatilitiUp4+VolatilitiUp5+VolatilitiUp6)};
   int IndMax=ArrayMaximum(Array23,WHOLE_ARRAY,0);
   Volatiliti=Array23[IndMax];
}
if(VolatilitiLow1>0&&VolatilitiLow2==0&&VolatilitiLow3==0&&VolatilitiLow4>0&&VolatilitiLow5>0&&VolatilitiLow6>0)
{
   double Array24[]={VolatilitiLow1,(VolatilitiUp2+VolatilitiUp3),(VolatilitiLow4+VolatilitiLow5+VolatilitiLow6)};
   int IndMax=ArrayMaximum(Array24,WHOLE_ARRAY,0);
   Volatiliti=Array24[IndMax];
}
if(VolatilitiLow1>0&&VolatilitiLow2==0&&VolatilitiLow3==0&&VolatilitiLow4>0&&VolatilitiLow5>0&&VolatilitiLow6==0)
{
   double Array25[]={VolatilitiLow1,(VolatilitiUp2+VolatilitiUp3),(VolatilitiLow4+VolatilitiLow5),VolatilitiUp6};
   int IndMax=ArrayMaximum(Array25,WHOLE_ARRAY,0);
   Volatiliti=Array25[IndMax];
}
if(VolatilitiLow1>0&&VolatilitiLow2==0&&VolatilitiLow3==0&&VolatilitiLow4>0&&VolatilitiLow5==0&&VolatilitiLow6>0)
{
   double Array26[]={VolatilitiLow1,(VolatilitiUp2+VolatilitiUp3),VolatilitiLow4,VolatilitiUp5,VolatilitiLow6};
   int IndMax=ArrayMaximum(Array26,WHOLE_ARRAY,0);
   Volatiliti=Array26[IndMax];
}
if(VolatilitiLow1>0&&VolatilitiLow2==0&&VolatilitiLow3==0&&VolatilitiLow4>0&&VolatilitiLow5==0&&VolatilitiLow6==0)
{
   double Array27[]={VolatilitiLow1,(VolatilitiUp2+VolatilitiUp3),VolatilitiLow4,(VolatilitiUp5+VolatilitiUp6)};
   int IndMax=ArrayMaximum(Array27,WHOLE_ARRAY,0);
   Volatiliti=Array27[IndMax];
}
if(VolatilitiLow1>0&&VolatilitiLow2==0&&VolatilitiLow3==0&&VolatilitiLow4==0&&VolatilitiLow5>0&&VolatilitiLow6>0)
{
   double Array28[]={VolatilitiLow1,(VolatilitiUp2+VolatilitiUp3+VolatilitiUp4),(VolatilitiLow5+VolatilitiLow6)};
   int IndMax=ArrayMaximum(Array28,WHOLE_ARRAY,0);
   Volatiliti=Array28[IndMax];
}
if(VolatilitiLow1>0&&VolatilitiLow2==0&&VolatilitiLow3==0&&VolatilitiLow4==0&&VolatilitiLow5>0&&VolatilitiLow6==0)
{
   double Array29[]={VolatilitiLow1,(VolatilitiUp2+VolatilitiUp3+VolatilitiUp4),VolatilitiLow5,VolatilitiUp6};
   int IndMax=ArrayMaximum(Array29,WHOLE_ARRAY,0);
   Volatiliti=Array29[IndMax];
}
if(VolatilitiLow1>0&&VolatilitiLow2==0&&VolatilitiLow3==0&&VolatilitiLow4==0&&VolatilitiLow5==0&&VolatilitiLow6>0)
{
   double Array30[]={VolatilitiLow1,(VolatilitiUp2+VolatilitiUp3+VolatilitiUp4+VolatilitiUp5),VolatilitiLow6};
   int IndMax=ArrayMaximum(Array30,WHOLE_ARRAY,0);
   Volatiliti=Array30[IndMax];
}
if(VolatilitiLow1>0&&VolatilitiLow2==0&&VolatilitiLow3==0&&VolatilitiLow4==0&&VolatilitiLow5==0&&VolatilitiLow6==0)
{
   double Array31[]={VolatilitiLow1,(VolatilitiUp2+VolatilitiUp3+VolatilitiUp4+VolatilitiUp5+VolatilitiUp6)};
   int IndMax=ArrayMaximum(Array31,WHOLE_ARRAY,0);
   Volatiliti=Array31[IndMax];
}
if(VolatilitiLow1==0&&VolatilitiLow2>0&&VolatilitiLow3>0&&VolatilitiLow4>0&&VolatilitiLow5>0&&VolatilitiLow6>0)
{
   double Array32[]={VolatilitiUp1,(VolatilitiLow2+VolatilitiLow3+VolatilitiLow4+VolatilitiLow5+VolatilitiLow6)};
   int IndMax=ArrayMaximum(Array32,WHOLE_ARRAY,0);
   Volatiliti=Array32[IndMax];
}
if(VolatilitiLow1==0&&VolatilitiLow2>0&&VolatilitiLow3>0&&VolatilitiLow4>0&&VolatilitiLow5>0&&VolatilitiLow6==0)
{
   double Array33[]={VolatilitiUp1,(VolatilitiLow2+VolatilitiLow3+VolatilitiLow4+VolatilitiLow5),VolatilitiUp6};
   int IndMax=ArrayMaximum(Array33,WHOLE_ARRAY,0);
   Volatiliti=Array33[IndMax];
}
if(VolatilitiLow1==0&&VolatilitiLow2>0&&VolatilitiLow3>0&&VolatilitiLow4>0&&VolatilitiLow5==0&&VolatilitiLow6>0)
{
   double Array34[]={VolatilitiUp1,(VolatilitiLow2+VolatilitiLow3+VolatilitiLow4),VolatilitiUp5,VolatilitiLow6};
   int IndMax=ArrayMaximum(Array34,WHOLE_ARRAY,0);
   Volatiliti=Array34[IndMax];
}
if(VolatilitiLow1==0&&VolatilitiLow2>0&&VolatilitiLow3>0&&VolatilitiLow4>0&&VolatilitiLow5==0&&VolatilitiLow6==0)
{
   double Array35[]={VolatilitiUp1,(VolatilitiLow2+VolatilitiLow3+VolatilitiLow4),(VolatilitiUp5+VolatilitiUp6)};
   int IndMax=ArrayMaximum(Array35,WHOLE_ARRAY,0);
   Volatiliti=Array35[IndMax];
}
if(VolatilitiLow1==0&&VolatilitiLow2>0&&VolatilitiLow3>0&&VolatilitiLow4==0&&VolatilitiLow5>0&&VolatilitiLow6>0)
{
   double Array36[]={VolatilitiUp1,(VolatilitiLow2+VolatilitiLow3),VolatilitiUp4,(VolatilitiLow5+VolatilitiLow6)};
   int IndMax=ArrayMaximum(Array36,WHOLE_ARRAY,0);
   Volatiliti=Array36[IndMax];
}
if(VolatilitiLow1==0&&VolatilitiLow2>0&&VolatilitiLow3>0&&VolatilitiLow4==0&&VolatilitiLow5>0&&VolatilitiLow6==0)
{
   double Array37[]={VolatilitiUp1,(VolatilitiLow2+VolatilitiLow3),VolatilitiUp4,VolatilitiLow5,VolatilitiUp6};
   int IndMax=ArrayMaximum(Array37,WHOLE_ARRAY,0);
   Volatiliti=Array37[IndMax];
}
if(VolatilitiLow1==0&&VolatilitiLow2>0&&VolatilitiLow3>0&&VolatilitiLow4==0&&VolatilitiLow5==0&&VolatilitiLow6>0)
{
   double Array38[]={VolatilitiUp1,(VolatilitiLow2+VolatilitiLow3),(VolatilitiUp4+VolatilitiUp5),VolatilitiLow6};
   int IndMax=ArrayMaximum(Array38,WHOLE_ARRAY,0);
   Volatiliti=Array38[IndMax];
}
if(VolatilitiLow1==0&&VolatilitiLow2>0&&VolatilitiLow3>0&&VolatilitiLow4==0&&VolatilitiLow5==0&&VolatilitiLow6==0)
{
   double Array39[]={VolatilitiUp1,(VolatilitiLow2+VolatilitiLow3),(VolatilitiUp4+VolatilitiUp5+VolatilitiUp6)};
   int IndMax=ArrayMaximum(Array39,WHOLE_ARRAY,0);
   Volatiliti=Array39[IndMax];
}
if(VolatilitiLow1==0&&VolatilitiLow2>0&&VolatilitiLow3==0&&VolatilitiLow4>0&&VolatilitiLow5>0&&VolatilitiLow6>0)
{
   double Array40[]={VolatilitiUp1,VolatilitiLow2,VolatilitiUp3,(VolatilitiLow4+VolatilitiLow5+VolatilitiLow6)};
   int IndMax=ArrayMaximum(Array40,WHOLE_ARRAY,0);
   Volatiliti=Array40[IndMax];
}
if(VolatilitiLow1==0&&VolatilitiLow2>0&&VolatilitiLow3==0&&VolatilitiLow4>0&&VolatilitiLow5>0&&VolatilitiLow6==0)
{
   double Array41[]={VolatilitiUp1,VolatilitiLow2,VolatilitiUp3,(VolatilitiLow4+VolatilitiLow5),VolatilitiUp6};
   int IndMax=ArrayMaximum(Array41,WHOLE_ARRAY,0);
   Volatiliti=Array41[IndMax];
}
if(VolatilitiLow1==0&&VolatilitiLow2>0&&VolatilitiLow3==0&&VolatilitiLow4>0&&VolatilitiLow5==0&&VolatilitiLow6>0)
{
   double Array42[]={VolatilitiUp1,VolatilitiLow2,VolatilitiUp3,VolatilitiLow4,VolatilitiUp5,VolatilitiLow6};
   int IndMax=ArrayMaximum(Array42,WHOLE_ARRAY,0);
   Volatiliti=Array42[IndMax];
}
if(VolatilitiLow1==0&&VolatilitiLow2>0&&VolatilitiLow3==0&&VolatilitiLow4>0&&VolatilitiLow5==0&&VolatilitiLow6==0)
{
   double Array43[]={VolatilitiUp1,VolatilitiLow2,VolatilitiUp3,VolatilitiLow4,(VolatilitiUp5+VolatilitiUp6)};
   int IndMax=ArrayMaximum(Array43,WHOLE_ARRAY,0);
   Volatiliti=Array43[IndMax];
}
if(VolatilitiLow1==0&&VolatilitiLow2>0&&VolatilitiLow3==0&&VolatilitiLow4==0&&VolatilitiLow5>0&&VolatilitiLow6>0)
{
   double Array44[]={VolatilitiUp1,VolatilitiLow2,(VolatilitiUp3+VolatilitiUp4),(VolatilitiLow5+VolatilitiLow6)};
   int IndMax=ArrayMaximum(Array44,WHOLE_ARRAY,0);
   Volatiliti=Array44[IndMax];
}
if(VolatilitiLow1==0&&VolatilitiLow2>0&&VolatilitiLow3==0&&VolatilitiLow4==0&&VolatilitiLow5>0&&VolatilitiLow6==0)
{
   double Array45[]={VolatilitiUp1,VolatilitiLow2,(VolatilitiUp3+VolatilitiUp4),VolatilitiLow5,VolatilitiUp6};
   int IndMax=ArrayMaximum(Array45,WHOLE_ARRAY,0);
   Volatiliti=Array45[IndMax];
}
if(VolatilitiLow1==0&&VolatilitiLow2>0&&VolatilitiLow3==0&&VolatilitiLow4==0&&VolatilitiLow5==0&&VolatilitiLow6>0)
{
   double Array46[]={VolatilitiUp1,VolatilitiLow2,(VolatilitiUp3+VolatilitiUp4+VolatilitiUp5),VolatilitiLow6};
   int IndMax=ArrayMaximum(Array46,WHOLE_ARRAY,0);
   Volatiliti=Array46[IndMax];
}
if(VolatilitiLow1==0&&VolatilitiLow2>0&&VolatilitiLow3==0&&VolatilitiLow4==0&&VolatilitiLow5==0&&VolatilitiLow6==0)
{
   double Array47[]={VolatilitiUp1,VolatilitiLow2,(VolatilitiUp3+VolatilitiUp4+VolatilitiUp5+VolatilitiUp6)};
   int IndMax=ArrayMaximum(Array47,WHOLE_ARRAY,0);
   Volatiliti=Array47[IndMax];
}
if(VolatilitiLow1==0&&VolatilitiLow2==0&&VolatilitiLow3>0&&VolatilitiLow4>0&&VolatilitiLow5>0&&VolatilitiLow6>0)
{
   double Array48[]={(VolatilitiUp1+VolatilitiUp2),(VolatilitiLow3+VolatilitiLow4+VolatilitiLow5+VolatilitiLow6)};
   int IndMax=ArrayMaximum(Array48,WHOLE_ARRAY,0);
   Volatiliti=Array48[IndMax];
}
if(VolatilitiLow1==0&&VolatilitiLow2==0&&VolatilitiLow3>0&&VolatilitiLow4>0&&VolatilitiLow5>0&&VolatilitiLow6==0)
{
   double Array49[]={(VolatilitiUp1+VolatilitiUp2),(VolatilitiLow3+VolatilitiLow4+VolatilitiLow5),VolatilitiUp6};
   int IndMax=ArrayMaximum(Array49,WHOLE_ARRAY,0);
   Volatiliti=Array49[IndMax];
}
if(VolatilitiLow1==0&&VolatilitiLow2==0&&VolatilitiLow3>0&&VolatilitiLow4>0&&VolatilitiLow5==0&&VolatilitiLow6>0)
{
   double Array50[]={(VolatilitiUp1+VolatilitiUp2),(VolatilitiLow3+VolatilitiLow4),VolatilitiUp5,VolatilitiLow6};
   int IndMax=ArrayMaximum(Array50,WHOLE_ARRAY,0);
   Volatiliti=Array50[IndMax];
}
if(VolatilitiLow1==0&&VolatilitiLow2==0&&VolatilitiLow3>0&&VolatilitiLow4>0&&VolatilitiLow5==0&&VolatilitiLow6==0)
{
   double Array51[]={(VolatilitiUp1+VolatilitiUp2),(VolatilitiLow3+VolatilitiLow4),(VolatilitiUp5+VolatilitiUp6)};
   int IndMax=ArrayMaximum(Array51,WHOLE_ARRAY,0);
   Volatiliti=Array51[IndMax];
}
if(VolatilitiLow1==0&&VolatilitiLow2==0&&VolatilitiLow3>0&&VolatilitiLow4==0&&VolatilitiLow5>0&&VolatilitiLow6>0)
{
   double Array52[]={(VolatilitiUp1+VolatilitiUp2),VolatilitiLow3,VolatilitiUp4,(VolatilitiLow5+VolatilitiLow6)};
   int IndMax=ArrayMaximum(Array52,WHOLE_ARRAY,0);
   Volatiliti=Array52[IndMax];
}
if(VolatilitiLow1==0&&VolatilitiLow2==0&&VolatilitiLow3>0&&VolatilitiLow4==0&&VolatilitiLow5>0&&VolatilitiLow6==0)
{
   double Array53[]={(VolatilitiUp1+VolatilitiUp2),VolatilitiLow3,VolatilitiUp4,VolatilitiLow5,VolatilitiUp6};
   int IndMax=ArrayMaximum(Array53,WHOLE_ARRAY,0);
   Volatiliti=Array53[IndMax];
}
if(VolatilitiLow1==0&&VolatilitiLow2==0&&VolatilitiLow3>0&&VolatilitiLow4==0&&VolatilitiLow5==0&&VolatilitiLow6>0)
{
   double Array54[]={(VolatilitiUp1+VolatilitiUp2),VolatilitiLow3,(VolatilitiUp4+VolatilitiUp5),VolatilitiLow6};
   int IndMax=ArrayMaximum(Array54,WHOLE_ARRAY,0);
   Volatiliti=Array54[IndMax];
}
if(VolatilitiLow1==0&&VolatilitiLow2==0&&VolatilitiLow3>0&&VolatilitiLow4==0&&VolatilitiLow5==0&&VolatilitiLow6==0)
{
   double Array55[]={(VolatilitiUp1+VolatilitiUp2),VolatilitiLow3,(VolatilitiUp4+VolatilitiUp5+VolatilitiUp6)};
   int IndMax=ArrayMaximum(Array55,WHOLE_ARRAY,0);
   Volatiliti=Array55[IndMax];
}
if(VolatilitiLow1==0&&VolatilitiLow2==0&&VolatilitiLow3==0&&VolatilitiLow4>0&&VolatilitiLow5>0&&VolatilitiLow6>0)
{
   double Array56[]={(VolatilitiUp1+VolatilitiUp2+VolatilitiUp3),(VolatilitiLow4+VolatilitiLow5+VolatilitiLow6)};
   int IndMax=ArrayMaximum(Array56,WHOLE_ARRAY,0);
   Volatiliti=Array56[IndMax];
}
if(VolatilitiLow1==0&&VolatilitiLow2==0&&VolatilitiLow3==0&&VolatilitiLow4>0&&VolatilitiLow5>0&&VolatilitiLow6==0)
{
   double Array57[]={(VolatilitiUp1+VolatilitiUp2+VolatilitiUp3),(VolatilitiLow4+VolatilitiLow5),VolatilitiUp6};
   int IndMax=ArrayMaximum(Array57,WHOLE_ARRAY,0);
   Volatiliti=Array57[IndMax];
}
if(VolatilitiLow1==0&&VolatilitiLow2==0&&VolatilitiLow3==0&&VolatilitiLow4>0&&VolatilitiLow5==0&&VolatilitiLow6>0)
{
   double Array58[]={(VolatilitiUp1+VolatilitiUp2+VolatilitiUp3),VolatilitiLow4,VolatilitiUp5,VolatilitiLow6};
   int IndMax=ArrayMaximum(Array58,WHOLE_ARRAY,0);
   Volatiliti=Array58[IndMax];
}
if(VolatilitiLow1==0&&VolatilitiLow2==0&&VolatilitiLow3==0&&VolatilitiLow4>0&&VolatilitiLow5==0&&VolatilitiLow6==0)
{
   double Array59[]={(VolatilitiUp1+VolatilitiUp2+VolatilitiUp3),VolatilitiLow4,(VolatilitiUp5+VolatilitiUp6)};
   int IndMax=ArrayMaximum(Array59,WHOLE_ARRAY,0);
   Volatiliti=Array59[IndMax];
}
if(VolatilitiLow1==0&&VolatilitiLow2==0&&VolatilitiLow3==0&&VolatilitiLow4==0&&VolatilitiLow5>0&&VolatilitiLow6>0)
{
   double Array60[]={(VolatilitiUp1+VolatilitiUp2+VolatilitiUp3+VolatilitiUp4),(VolatilitiLow5+VolatilitiLow6)};
   int IndMax=ArrayMaximum(Array60,WHOLE_ARRAY,0);
   Volatiliti=Array60[IndMax];
}
if(VolatilitiLow1==0&&VolatilitiLow2==0&&VolatilitiLow3==0&&VolatilitiLow4==0&&VolatilitiLow5>0&&VolatilitiLow6==0)
{
   double Array61[]={(VolatilitiUp1+VolatilitiUp2+VolatilitiUp3+VolatilitiUp4),VolatilitiLow5,VolatilitiUp6};
   int IndMax=ArrayMaximum(Array61,WHOLE_ARRAY,0);
   Volatiliti=Array61[IndMax];
}
if(VolatilitiLow1==0&&VolatilitiLow2==0&&VolatilitiLow3==0&&VolatilitiLow4==0&&VolatilitiLow5==0&&VolatilitiLow6>0)
{
   double Array62[]={(VolatilitiUp1+VolatilitiUp2+VolatilitiUp3+VolatilitiUp4+VolatilitiUp5),VolatilitiLow6};
   int IndMax=ArrayMaximum(Array62,WHOLE_ARRAY,0);
   Volatiliti=Array62[IndMax];
}
if(VolatilitiLow1==0&&VolatilitiLow2==0&&VolatilitiLow3==0&&VolatilitiLow4==0&&VolatilitiLow5==0&&VolatilitiLow6==0)
{
   Volatiliti=VolatilitiUp1+VolatilitiUp2+VolatilitiUp3+VolatilitiUp4+VolatilitiUp5+VolatilitiUp6;
}
  

  MqlTick mqlTick[], symbTick; // объявили переменные
  CopyTicksRange(_Symbol, mqlTick, COPY_TICKS_INFO, symbTick.time_msc, symbTick.time_msc-300); // цены за последний период
  for(int i = 0; i < ArraySize(mqlTick); i++)
  {
     double bid1 = NormalizeDouble(mqlTick[0].bid, _Digits); // первая цена bid за последний период
     double ask1 = NormalizeDouble(mqlTick[0].ask, _Digits); // первая цена ask за последний период
      if(!PositionSelect(Symbol())) // Нет открытых позиций
        {
Print("spred=",(string)spred," Volatiliti=",(string)(Volatiliti)," VolatilitiUp1=",(string)VolatilitiUp1," VolatilitiLow1=",(string)VolatilitiLow1);
            if(spred < 0)
            {
                m_trade.Buy(LotSize,Symbol(),ask0,NULL,NULL,NULL);
                m_trade.Sell(LotSize,Symbol(),bid0,NULL,NULL,NULL);
                Print("2 бай,селл, spred < 0");
            }
            if(spred >= 0 && ((spred <= VolatilitiUp1 && VolatilitiLow1 == 0) || spred < Volatiliti) && (ask0 > ask1 && bid0 > bid1))
            {
               m_trade.Buy(LotSize,Symbol(),ask0,NULL,NULL,NULL);
Print("2 бай, spred >= 0 && ((spred <= VolatilitiUp1 && VolatilitiLow1 == 0) || spred < Volatiliti) && (ask0 > ask1 && bid0 > bid1)");
            }
            if(spred >= 0 && ((spred <= VolatilitiLow1 && VolatilitiUp1 == 0) || spred < Volatiliti) && (ask0 < ask1 && bid0 < bid1))
            {
               m_trade.Sell(LotSize,Symbol(),bid0,NULL,NULL,NULL);
Print("3 селл, spred >= 0 && ((spred <= VolatilitiLow1 && VolatilitiUp1 == 0) || spred < Volatiliti) && (ask0 < ask1 && bid0 < bid1)");
            }
        }
        if(PositionSelect(Symbol())) // Есть открытые позиции
        {
            //Print("Есть открытые позиции");
            if(spred < 0 && Type == POSITION_TYPE_BUY && bid0 > Price)
            {
               Print("1 spred < 0 && Type == POSITION_TYPE_BUY && bid0 > Price");
               if(m_trade.PositionClose(m_position_ticket)) Print("1 закрыли");
            }
            if(spred < 0 && Type == POSITION_TYPE_SELL && ask0 < Price)
            {
               Print("2 spred < 0 && Type == POSITION_TYPE_SELL && ask0 < Price");
               if(m_trade.PositionClose(m_position_ticket)) Print("2 закрыли");
            }
            if(spred > 0 && Type == POSITION_TYPE_BUY && (bid0 + spred < bid1 || ask0 + spred < ask1))
            {
               Print("3 spred > 0 && Type == POSITION_TYPE_BUY && (bid0 + spred < bid1 || ask0 + spred < ask1)");
               if(m_trade.PositionClose(m_position_ticket)) Print("3 закрыли");
            }
            if(spred > 0 && Type == POSITION_TYPE_SELL && (ask0 > ask1 + spred || bid0 > bid1 + spred))
            {
               Print("4 spred > 0 && Type == POSITION_TYPE_SELL && (ask0 > ask1 + spred || bid0 > bid1 + spred)");
               if(m_trade.PositionClose(m_position_ticket)) Print("4 закрыли");
            }
        }
     }
}

//+------------------------------------------------------------------+
//| Refreshes the symbol quotes data                                 |
//+------------------------------------------------------------------+
bool RefreshRates(void)
  {
   if(!m_symbol.RefreshRates())
     {
      Print("RefreshRates error");
      return(false);
     }
//--- protection against the return value of "zero"
   if(m_symbol.Ask()==0 || m_symbol.Bid()==0)
      return(false);
//---
   return(true);
  }

//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
{
   EventKillTimer();
}
